%global __python %{__python3}
%global python python3

Summary:	Key fingerprinting tools for CVE-2017-15361
Name:		roca-detect
Version:	1.2.1
Release:	6%{?dist}
License:	MIT
Url:		https://crocs.fi.muni.cz/public/papers/rsa_ccs17
Source0:	https://github.com/crocs-muni/roca/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz

# Remove coloredlogs dependency as it is not in Fedora as of f28
Patch0:		roca-detect-color.patch

BuildRequires:	%{python}-future %{python}-cryptography %{python}-pgpdump 
BuildRequires:	%{python}-setuptools %{python}-devel

# NOTE: no python2-pgpdump in Fedora or epel
Requires:	%{python}-future %{python}-cryptography %{python}-pgpdump
%if 0%{?rhel} <= 7
Requires:	python-dateutil
%else
Requires:	%{python}-dateutil
%endif
BuildArch:	noarch

%description
This tool is related to the ACM CCS 2017 conference paper #124 Return of the
Coppersmith’s Attack: Practical Factorization of Widely Used RSA
Moduli.

https://crocs.fi.muni.cz/public/papers/rsa_ccs17

Install this to test public RSA keys for the presence of the vulnerability
described by CVE-2017-15361.


%prep
%setup -q -n roca-%{version}
%patch0 -p0 -b .color

# fix env shbang in cli scripts
sed -i -e '1,1 s,^#!.*$,#!%{__python} %{py_shbang_opts},' roca/detect*.py

%build
%py_build


%install
%py_install

# Replace complex "EASY" universal wrapper with symlinks to cli scripts.
chmod a+x %{buildroot}%{python_sitelib}/roca/detect*.py 
ln -sf %{python_sitelib}/roca/detect.py %{buildroot}%{_bindir}/roca-detect
ln -sf %{python_sitelib}/roca/detect_tls.py %{buildroot}%{_bindir}/roca-detect-tls


%check
%{__python} -m unittest discover


%files
%doc README.md docs
%license LICENSE
%{_bindir}/roca-detect*
%{python_sitelib}/roca
%{python_sitelib}/roca_detect-%{version}*


%changelog
* Tue Sep  4 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-6
- Patch cli scripts and symlink to them directly.
- Add additional help to roca-detect-tls

* Tue Sep  4 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-5
- Format SPEC with tabs and double space between sections
- Split wrapper import into 2 lines 

* Tue Sep  4 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-4
- More changes from package review:
- Keep upstream introducer name and symlink to it
- Specify an additional directory level after sitelib in files

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-3
- More suggestions from package review

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-2
- Change more nits from Fedora package review

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-1
- py3 support
- New upstream release

* Thu Oct 19 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-3
- SPEC file nits from Fedora package review

* Wed Oct 18 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-2
- Ditch the "EASY" introducer that requires setuptools >= 1.0

* Wed Oct 18 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-1
- Initial rpm
